#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
 * ------------------------------------------------------------------------
 * bmSearch
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.bm-stats.org <http://www.bm-stats.org>
 * ------------------------------------------------------------------------
"""

# Native Python Lib/Class 
import json
import time

# bmSearch Class
import config
from logger import *
from mailLogParser import *
from requestToELK import *

class bmSearch:
        """
        bmSearch Class 
                main class from which we call all methods/classes to parse, retrieve pertinent values and post then to an Elasticsearch engine.        
        
        """
      
        def __init__(self,**kwargs):                
                """
                __init__ :
                        constructor accept kwargs

                        **kwargs: 
                                                file   : path to file to parse. I can be plain text, gzip or bzip2 compressed. By default what configured in /etc/bmSearch/config.py

                                                method : how to read the file, 2 possibilities
                                                        - "file" : read the file and exit after reach end file. By default.
                                                        - "stream" : connect to the file and stream data. No exit while programm running

                                                action : tell what to do, 2 cases
                                                        - "storeToELK"  : to store in Elasticsearch instance configured in /etc/bmSearch/config.py
                                                        - "updateToELK" : to update in Elasticsearch instance data (deliveredRecip)
                                        
                        Constructor call mailLogParser(**kwargs), mailLogParser().getFileContent(), mailLogParser().parseContent() and mailLogParser().updateEntry()
                """
		
		"""
		LOGGER
		"""
		self.logger = logger()

		try:
                	self.p = mailLogParser()
                	self.p.setParam(**dict(kwargs))
                	self.p.parseContent()

        	except Exception :
    			self.logger.catch('bmSearch::')




		


		

