#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
 * ------------------------------------------------------------------------
 * bmSearch
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.bm-stats.org <http://www.bm-stats.org>
 * ------------------------------------------------------------------------
"""

# Native Python Lib/Class 
from datetime import *
import io
import os
import re
import subprocess
import time


# bmSearch Class
from bmDate import *
import config
from regex import *
from requestToELK import *



class updateCyrusTags:
        """
        updateCyrusTags :
                Has to open mail.log file,
                parse each line since a block address 
                try to update ELK entries (messages)
        """

        def __init__(self):
                """
                __init__ : 
                        constructor
                """

                """
                Regex :
                
                Cyrus/IMAP : this line is relative to a délivery success
                """
                self.cyrusDelivered = cyrusDelivered

                
                """
                DATE
                """
                self.dates = bmDate().getCyrusUpdatePoolDates()
                self.Dates = bmDate().getDates()
		self.now   = datetime.today().strftime("%H:%M")
		
		"""
		Others
		"""
		self.initpos = None     
		
		   
        
	def setParam(self, **kwargs):
                """
                setParam : 
                        set paramaters from config file or kwagrs
                        
                        **kwargs
                                                file   : path to file to parse. I can be plain text, gzip or bzip2 compressed. By default what configured in /etc/bmSearch/config.py
                                                
                                                timeInterval : time expressed in second when to sleep the update process between two ELK connection 
                        
                """
	        # For Python re 
	        linesStartWithPattern = "^("+ "|".join(self.dates)+")"
		self.startLine = re.compile(linesStartWithPattern)
	
		# For file seek 
		self.indexmax = 5

		if self.now == "00:00":
			self.maillog = config.oldermaillog		
		else:
               		self.maillog = config.maillog

		if "file" in kwargs.keys():
                        self.maillog = kwargs['file']

                        
		self.timeInterval = config.timeInterval
		if "timeInterval" in kwargs.keys():
			self.timeInterval = kwargs['timeInterval']
			
			        

        def getStartsBlockReading(self):
                '''
                getStartsBlockReading:
                        Retrieve the file block address where to start reading when line matches with self.initFirstLinePattern (cf setParam)
                
                '''
		n = 0
		while n < self.indexmax:
			initFirstLinePattern = self.initFirstLinePattern = '"^'+self.dates[n]+'"'

               		grepCmd="grep -m 1 -b -e " + initFirstLinePattern + " " + self.maillog + " |cut -d':' -f1"
                	r = subprocess.Popen(grepCmd, shell=True, stdout=subprocess.PIPE)
                	pos = r.communicate()[0]
		
			if pos.rstrip().isdigit():                 
				self.initpos = int(pos.rstrip())
                		break
			n +=1


                
        def getFileContent(self):
                """
                getFileContent :
                        Read a file from a starting block address.  The filename is from config or from kwargs "file" (cf setParam).
                        
                
                """
                self.getStartsBlockReading()
                
		if self.initpos is None or isinstance( self.initpos, ( int, long ) ):
			exit 

                try:
			self.maillog    = self.maillog.encode('utf8')
		        f = open(self.maillog , 'r' )
		        f.seek(self.initpos, 0)
		        content = f.readlines() 
		        f.close()        

		        for line in content:
		                thisLine = line.rstrip()
		                startLineEntries = self.startLine.match(thisLine)
		                if startLineEntries is not None:
		        	        yield line
        	except Exception as error:
    			pass	



	def parseContent(self):
                """
                parseContent :
                        read line from getFileContent(), and call cf parseLine()

                """

		for line in self.getFileContent():
			self.parseLine(line)



        def parseLine(self, line):
                """
                parseLine :
                        read line  and extract data, and try to update an ELK entry (cf requestToELK Class)

                """

                thisLine = line.rstrip()
    
                cyrusDeliveredEntries = self.cyrusDelivered.match(thisLine)        
                if cyrusDeliveredEntries is not None:
		        date      = self.Dates[cyrusDeliveredEntries.group('date')]
                        hour      = cyrusDeliveredEntries.group('hour')
                        messageid = cyrusDeliveredEntries.group('messageid').replace("<","").replace(">","")
                        domain    = cyrusDeliveredEntries.group('domain')
                        user      = cyrusDeliveredEntries.group('user')
                        
                        recip = user.replace("^", ".") + "@" + domain 
                        deliveredRecip = "" 
			deliveredRecip = recip + ": the " + date + " at " + hour
			
			u = requestToELK()
			time.sleep(self.timeInterval)
			u.retrieveBmsearchId(messageid)
                        u.updateDeliveredRecip(deliveredRecip)
                        	
				

		
		
		
		
