#!/bin/bash

# **
# * ------------------------------------------------------------------------
# * bmSearch
# * ------------------------------------------------------------------------
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
# * @author  : Pascal SALAUN 
# * @Website : http://bm-stats.org/ <http://bm-stats.org/>
# * ------------------------------------------------------------------------
# **

PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
export PATH

chmod 644 /etc/cron.d/bmSearch 

###  Check if bm-stats is already installed  ####
if [ -f "/usr/share/bm-stats/scripts/SHELL/MailLogRotate.sh" ] ; then
        echo "Oh, bm-stats is installed, thanks a lot !"
        echo " We are just disabling mail log rotation from bmSearch cron file"
        
        sed -i -e "s/\(.*#bmStatsAlreadyInstalled.*\)/#\1/" -e "/^#/s/#\{2,\}/#/g" /etc/cron.d/bmSearch

fi


### Setting Logs Management####
# which daemon (rsyslog|syslog-ng|sysklogd) 
DaemomLog=`dpkg -l "*sys*log*" | grep ii | tr -s ' ' | cut -d ' ' -f2 | grep -v system|grep -v lib`
	    
if [ "$DaemomLog" = "rsyslog" ]; then
	if [ -f /etc/logrotate.d/rsyslog ]; then
		echo "Configuring /etc/logrotate.d/rsyslog"
		sed -i 's/\(^\/var\/log\/mail.*\)/#\1/g'  /etc/logrotate.d/rsyslog
	fi
fi

if [ "$DaemomLog" = "syslog-ng" ]; then
	if [ -f /etc/logrotate.d/syslog-ng ]; then
		echo "Configuring /etc/logrotate.d/syslog-ng"
		echo "The previous one saved as /etc/logrotate.d/syslog-ng-bmStats-BacKup.disabled"
		/usr/share/bmSearch/scripts/SHELL/Logrotate-SyslogNG-No-MailLog.sh
	fi
fi

echo "A logrotate of mail.log file will now be done each day at 00:00, and the the filelog \"2 days old\" "
echo "will be moved in /var/log/mail/ ";
if [ -f "/usr/share/bm-stats/scripts/SHELL/MailLogRotate.sh" ] ; then
        echo "See /usr/share/bmSearch/scripts/SHELL/MailLogRotate.sh for details"
else
        echo "See /usr/share/bmSearch/scripts/SHELL/MailLogRotate.sh for details"
fi


### Setting Postfix main.cf####
#
checkIfPostfixInstalled=$(dpkg -l postfix |grep -c ^ii )
if [ "$checkIfPostfixInstalled" = "1" ] ; then
        echo "Checking postfix PCRE rules for bmStats/bmSearch" 

        reloadPostfix=0

        testPostfixMimeHeaderCkeck=$(grep -c -e '^mime_header.*BM_mime_header_checks' /etc/postfix/main.cf)

        if [ "$testPostfixMimeHeaderCkeck" = 0 ]; then

                reloadPostfix=1
                if [ ! -f "/etc/postfix/BM_mime_header_checks" ] ; then
                        cp /etc/postfix/BMSTATS/BM_mime_header_checks /etc/postfix/.
	
                        echo "Adding postfix MIME HEADER PCRE rules for bmSearch" 
		        echo "" >> /etc/postfix/main.cf
		        echo "#bmStats PCRE Rules" >> /etc/postfix/main.cf
		        echo "mime_header_checks= pcre:/etc/postfix/BM_mime_header_checks" >> /etc/postfix/main.cf

                fi
        fi

        testPostfixHeaderCkeck=$(grep -c -e '^header_checks.*' /etc/postfix/main.cf)

        if [ "$testPostfixMimeHeaderCkeck" = 1 ]; then

                testPostfixBMSEARCH_header_check=$(grep -c -e '^header_checks.*BMSEARCH_header_checks' /etc/postfix/main.cf)

                if [ "$testPostfixBMSEARCH_header_check" = 0 ]; then
                        reloadPostfix=1
                        echo "Adding postfix PCRE rules for bmSearch to already existing ones" 
                        sed -i"_"$(date +%Y%m%d-%H%M%S)"_by_bmSearch" '/^header_checks/s/\(.*\)/\1, pcre:\/etc\/postfix\/BMSEARCH_header_checks/' /etc/postfix/main.cf
                fi  


        else
                reloadPostfix=1
                echo "Adding postfix PCRE rules for bmSearch" 
                echo "header_checks= pcre:/etc/postfix/BMSEARCH_header_checks" >> /etc/postfix/main.cf

        fi

        if [ "$reloadPostfix" = "1" ]; then
                echo "Have to reload postfix"
                service postfix reload
        fi
fi




exit 0
